//
// Created by 乾三 on 2023/3/2.
//

#ifndef YOLOV3_COLORCLASSIFY_VIDEO_HELMETPREPROCESS_H
#define YOLOV3_COLORCLASSIFY_VIDEO_HELMETPREPROCESS_H
#include "detectPreprocess.h"

class helmetPreprocessThread : public DetectPreprocessThread {
public:

    helmetPreprocessThread(const char*& configFile, int32_t deviceId,
                           int32_t channelId, aclrtRunMode& runMode, OnlyDetectNameInfo nameinfo,bool display = false,int skip = 5);
    ~helmetPreprocessThread();

    AclLiteError Init();
    AclLiteError Process(int msgId, std::shared_ptr<void> msgData);
    AclLiteError GetInputDataType(std::string& inputType, uint32_t channelId);
    AclLiteError MsgSend(std::shared_ptr<ObjDetectDataMsg> &objDetectDataMsg);

    AclLiteError GetInputDataPath(std::string& inputDataPath, uint32_t channelId);
    AclLiteError GetSkip(int &skip, uint32_t channelId);
//    AclLiteError ReadPic(std::shared_ptr<ObjDetectDataMsg> &objDetectDataMsg);

    AclLiteError OpenPicsDir();

    AclLiteError OpenVideoCapture();
//
//    AclLiteError GetInputDataType(std::string& inputType, uint32_t channelId);

    AclLiteError AppStart();

    AclLiteError ReadStream(std::shared_ptr<ObjDetectDataMsg> &objDetectDataMsg);

    AclLiteError MsgRead(std::shared_ptr<ObjDetectDataMsg> &objDetectDataMsg);

    AclLiteError MsgProcess(std::shared_ptr<ObjDetectDataMsg> &objDetectDataMsg);

    int skipframe_ = 24;
private:
//    const std::string kDetectPreName_ = "helmetdetectPre";
    std::string kDetectPostName_ = "helmetdetectPost";
    std::string kInferName_ = "helmetinference";
    std::string krtspurl_ = "";
    std::string kMqttSendName_ = "";



};


#endif //YOLOV3_COLORCLASSIFY_VIDEO_HELMETPREPROCESS_H
