//
// Created by 乾三 on 2023/2/23.
//

#ifndef YOLOV3_COLORCLASSIFY_VIDEO_ONLYDETECTINFERENCE_H
#define YOLOV3_COLORCLASSIFY_VIDEO_ONLYDETECTINFERENCE_H
#pragma once

#include <iostream>
#include <mutex>
#include <unistd.h>
#include "acl/acl.h"
#include "AclLiteModel.h"
#include "AclLiteImageProc.h"
#include "AclLiteThread.h"
#include "CarParams.h"
#include "inference.h"

class helmetDetectInferenceThread : public InferenceThread {
public:

    helmetDetectInferenceThread(aclrtRunMode& runMode, const int type = 0);
    ~helmetDetectInferenceThread();

    AclLiteError Init();
    AclLiteError Process(int msgId, std::shared_ptr<void> data);
    AclLiteError ModelSwith(int type);
private:
//    AclLiteError InitModelInput();
    AclLiteError DetectMsgSend(std::shared_ptr<ObjDetectDataMsg> objDetectDataMsg);
    AclLiteError DetectModelExecute(std::shared_ptr<ObjDetectDataMsg> objDetectDataMsg);

    void DestroyResource();
private:
    AclLiteModel detectModel_;
    AclLiteModel classifyModel_;
    aclrtRunMode runMode_;
    int32_t batchSize_;
    int flag_;
    int programtype_;
    std::string kDetectModelPath_;
    uint32_t classifyInputSize_;
    uint8_t* classifyInputBuf_;
    uint32_t imageInfoSize_;
    void* imageInfoBuf_;

};



#endif //YOLOV3_COLORCLASSIFY_VIDEO_ONLYDETECTINFERENCE_H
